package logic

import (
	"context"
	"fusenapi/product/internal/svc"
	"fusenapi/product/internal/types"
	"fusenapi/utils/auth"
	"github.com/zeromicro/go-zero/core/logx"
)

type GetProductInfoLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewGetProductInfoLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetProductInfoLogic {
	return &GetProductInfoLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

// 获取产品详情
func (l *GetProductInfoLogic) GetProductInfo(req *types.GetProductInfoReq, loginInfo auth.UserInfo) (resp *types.Response) {
	//校验前台登录情况
	/*if loginInfo.UserId == 0 {
		return &types.Response{Code: 402, Message: "please sign in"}
	}
	req.Pid = strings.Trim(req.Pid, " ")
	req.ClientNo = strings.Trim(req.ClientNo, " ")
	if req.Size > 0 {
		req.Size = image.GetCurrentSize(req.Size)
	}
	//获取产品详情
	productModel := model.NewFsProductModel(l.svcCtx.MysqlConn)
	productInfo, err := productModel.FindOneBySn(l.ctx, req.Pid)
	if err != nil && !errors.Is(err, sqlc.ErrNotFound) {
		logx.Error(err)
		return &types.Response{Code: 510, Message: "failed to get product info"}
	}
	if productInfo == nil {
		return &types.Response{Code: 510, Message: "product not found"}
	}
	//获取产品标签
	tagModel := model.NewFsTagsModel(l.svcCtx.MysqlConn)
	tagInfo, err := tagModel.FindOne(l.ctx, productInfo.Type)
	if err != nil {
		logx.Error(err)
		return &types.Response{Code: 510, Message: "failed to get product tag"}
	}
	//获取产品尺寸列表
	productSizeModel := model.NewFsProductSizeModel(l.svcCtx.MysqlConn)
	productSizeList, err := productSizeModel.FindAllByStatus(l.ctx, 1, 1)
	if err != nil {
		logx.Error(err)
		return &types.Response{Code: 510, Message: "failed to get product size list"}
	}
	sizeIds := make([]string, 0, len(productSizeList))
	for _, v := range productSizeList {
		sizeIds = append(sizeIds, fmt.Sprintf("%d", v.Id))
	}
	//获取这些尺寸下的模型数据
	productModel3dModel := model.NewFsProductModel3dModel(l.svcCtx.MysqlConn)
	models, err := productModel3dModel.ListBySizeIdsTag(l.ctx, sizeIds, 1)
	if err != nil {
		logx.Error(err)
		return &types.Response{Code: 510, Message: "failed to get product models"}
	}
	modelIds := make([]string, 0, len(models))
	for _, v := range models {
		modelIds = append(modelIds, fmt.Sprintf("%d", v.Id))
	}
	//通过产品id和模型id获取模板信息
	productTemplateV2Model := model.NewFsProductTemplateV2Model(l.svcCtx.MysqlConn)
	templateV2List, err := productTemplateV2Model.FindAllByModelIdsProduct(l.ctx, modelIds, productInfo.Id, 2)
	if err != nil {
		logx.Error(err)
		return &types.Response{Code: 510, Message: "failed to get templates"}
	}
	//获取模板包含的model_id
	templateModelIds := make([]string, 0, len(templateV2List))
	for _, v := range templateV2List {
		templateModelIds = append(templateModelIds, fmt.Sprintf("%d", v.ModelId))
	}*/
	return
}
